diff -r 1f2c537229ab trytond/modules/carrier_percentage/tests/test_carrier_percentage.py
--- a/trytond/modules/carrier_percentage/tests/test_carrier_percentage.py	Tue Sep 11 15:29:50 2012 +0200
+++ b/trytond/modules/carrier_percentage/tests/test_carrier_percentage.py	Mon Sep 24 20:36:40 2012 +0200
@@ -49,42 +49,40 @@
         Test compute_percentage.
         '''
         with Transaction().start(DB_NAME, USER, context=CONTEXT):
-            party_id = self.party.create({
+            party = self.party.create({
                     'name': 'Carrier',
                     })
-            uom_id, = self.uom.search([
+            uom, = self.uom.search([
                     ('name', '=', 'Unit'),
                     ])
-            category_id = self.category.create({
+            category = self.category.create({
                     'name': 'Category',
                     })
-            product_id = self.product.create({
+            product = self.product.create({
                     'name': 'Carrier',
-                    'default_uom': uom_id,
-                    'category': category_id,
+                    'default_uom': uom.id,
+                    'category': category.id,
                     'type': 'service',
                     'list_price': Decimal(0),
                     'cost_price': Decimal(0),
                     })
-            currency_id, = self.currency.search([
+            currency, = self.currency.search([
                     ('code', '=', 'cu1'),
                     ])
-            carrier_id = self.carrier.create({
-                    'party': party_id,
-                    'carrier_product': product_id,
+            carrier = self.carrier.create({
+                    'party': party.id,
+                    'carrier_product': product.id,
                     'carrier_cost_method': 'percentage',
                     'percentage': Decimal(15),
                     })
-            carrier = self.carrier.browse(carrier_id)
             for amount, price in [
                     (Decimal(0), Decimal(0)),
                     (Decimal(100), Decimal('15.00')),
                     (Decimal(150), Decimal('22.50')),
                     ]:
                 self.assertEqual(
-                    self.carrier.compute_percentage(carrier, amount,
-                        currency_id),
-                    (price, currency_id))
+                    carrier.compute_percentage(amount, currency.id),
+                    (price, currency.id))
 
 
 def doctest_dropdb(test):
diff -r b7bad438669f trytond/modules/carrier_weight/__init__.py
--- a/trytond/modules/carrier_weight/__init__.py	Thu Sep 13 12:41:15 2012 +0200
+++ b/trytond/modules/carrier_weight/__init__.py	Mon Sep 24 20:36:40 2012 +0200
@@ -1,6 +1,17 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from carrier import *
 from stock import *
 from sale import *
+
+
+def register():
+    Pool.register(
+        Carrier,
+        WeightPriceList,
+        ShipmentIn,
+        ShipmentOut,
+        Sale,
+        module='carrier_weight', type_='model')
diff -r b7bad438669f trytond/modules/carrier_weight/carrier.py
--- a/trytond/modules/carrier_weight/carrier.py	Thu Sep 13 12:41:15 2012 +0200
+++ b/trytond/modules/carrier_weight/carrier.py	Mon Sep 24 20:36:40 2012 +0200
@@ -1,17 +1,18 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-import copy
 from decimal import Decimal
 
-from trytond.model import Model, ModelSQL, ModelView, fields
+from trytond.model import ModelSQL, ModelView, fields
 from trytond.pyson import Eval, Bool, Id
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 from trytond.transaction import Transaction
 
+__all__ = ['Carrier', 'WeightPriceList']
+__metaclass__ = PoolMeta
 
-class Carrier(Model):
-    _name = 'carrier'
 
+class Carrier:
+    __name__ = 'carrier'
     weight_uom = fields.Many2One('product.uom', 'Weight Uom',
         domain=[('category', '=', Id('product', 'uom_cat_weight'))],
         states={
@@ -21,7 +22,7 @@
             },
         depends=['carrier_cost_method', 'weight_price_list'])
     weight_uom_digits = fields.Function(fields.Integer('Weight Uom Digits',
-            on_change_with=['weight_uom']), 'get_weight_uom_digits')
+            on_change_with=['weight_uom']), 'on_change_with_weight_uom_digits')
     weight_currency = fields.Many2One('currency.currency', 'Currency',
         states={
             'invisible': Eval('carrier_cost_method') != 'weight',
@@ -31,7 +32,7 @@
         depends=['carrier_cost_method', 'weight_price_list'])
     weight_currency_digits = fields.Function(fields.Integer(
             'Weight Currency Digits', on_change_with=['weight_currency']),
-        'get_weight_currency_digits')
+        'on_change_with_weight_currency_digits')
     weight_price_list = fields.One2Many('carrier.weight_price_list', 'carrier',
         'Price List',
         states={
@@ -40,98 +41,71 @@
             },
         depends=['carrier_cost_method', 'weight_uom', 'weight_currency'])
 
-    def __init__(self):
-        super(Carrier, self).__init__()
-        self.carrier_cost_method = copy.copy(self.carrier_cost_method)
-        self.carrier_cost_method.selection = \
-            self.carrier_cost_method.selection[:]
+    @classmethod
+    def __setup__(cls):
+        super(Carrier, cls).__setup__()
         selection = ('weight', 'Weight')
-        if selection not in self.carrier_cost_method.selection:
-            self.carrier_cost_method.selection.append(selection)
-        self._reset_columns()
+        if selection not in cls.carrier_cost_method.selection:
+            cls.carrier_cost_method.selection.append(selection)
 
-    def default_weight_uom_digits(self):
+    @staticmethod
+    def default_weight_uom_digits():
         return 2
 
-    def default_weight_currency_digits(self):
-        company_obj = Pool().get('company.company')
+    @staticmethod
+    def default_weight_currency_digits():
+        Company = Pool().get('company.company')
         company = Transaction().context.get('company')
         if company:
-            return company_obj.browse(company).currency.digits
+            return Company(company).currency.digits
         return 2
 
-    def on_change_with_weight_uom_digits(self, values):
-        uom_obj = Pool().get('product.uom')
-        if values.get('weight_uom'):
-            uom = uom_obj.browse(values['weight_uom'])
-            return uom.digits
+    def on_change_with_weight_uom_digits(self, name=None):
+        if self.weight_uom:
+            return self.weight_uom.digits
         return 2
 
-    def get_weight_uom_digits(self, ids, name):
-        digits = {}
-        for carrier in self.browse(ids):
-            if carrier.weight_uom:
-                digits[carrier.id] = carrier.weight_uom.digits
-            else:
-                digits[carrier.id] = 2
-        return digits
-
-    def on_change_with_weight_currency_digits(self, values):
-        currency_obj = Pool().get('currency.currency')
-        if values.get('weight_currency'):
-            currency = currency_obj.browse(values['weight_currency'])
-            return currency.digits
+    def on_change_with_weight_currency_digits(self, name=None):
+        if self.weight_currency:
+            return self.weight_currency.digits
         return 2
 
-    def get_weight_currency_digits(self, ids, name):
-        digits = {}
-        for carrier in self.browse(ids):
-            if carrier.weight_currency:
-                digits[carrier.id] = carrier.weight_currency.digits
-            else:
-                digits[carrier.id] = 2
-        return digits
-
-    def compute_weight_price(self, carrier, weight):
+    def compute_weight_price(self, weight):
         "Compute price based on weight"
-        for line in reversed(carrier.weight_price_list):
+        for line in reversed(self.weight_price_list):
             if line.weight < weight:
                 return line.price
         return Decimal(0)
 
-    def get_sale_price(self, carrier):
-        price, currency_id = super(Carrier, self).get_sale_price(carrier)
-        if carrier.carrier_cost_method == 'weight':
+    def get_sale_price(self):
+        price, currency_id = super(Carrier, self).get_sale_price()
+        if self.carrier_cost_method == 'weight':
             weight_price = Decimal(0)
             for weight in Transaction().context.get('weights', []):
-                weight_price += self.compute_weight_price(carrier, weight)
-            return weight_price, carrier.weight_currency.id
+                weight_price += self.compute_weight_price(weight)
+            return weight_price, self.weight_currency.id
         return price, currency_id
 
-    def get_purchase_price(self, carrier):
-        price, currency_id = super(Carrier, self).get_purchase_price(carrier)
-        if carrier.carrier_cost_method == 'weight':
+    def get_purchase_price(self):
+        price, currency_id = super(Carrier, self).get_purchase_price()
+        if self.carrier_cost_method == 'weight':
             weight_price = Decimal(0)
             for weight in Transaction().context.get('weights', []):
-                weight_price += self.compute_weight_price(carrier, weight)
-            return weight_price, carrier.weight_currency.id
+                weight_price += self.compute_weight_price(weight)
+            return weight_price, self.weight_currency.id
         return price, currency_id
 
-Carrier()
-
 
 class WeightPriceList(ModelSQL, ModelView):
     'Carrier Weight Price List'
-    _name = 'carrier.weight_price_list'
-
+    __name__ = 'carrier.weight_price_list'
     carrier = fields.Many2One('carrier', 'Carrier', required=True, select=True)
     weight = fields.Float('Weight',
         digits=(16, Eval('_parent_carrier.weight_uom_digits', 2)))
     price = fields.Numeric('Price',
         digits=(16, Eval('_parent_carrier.weight_currency_digits', 2)))
 
-    def __init__(self):
-        super(WeightPriceList, self).__init__()
-        self._order.insert(0, ('weight', 'ASC'))
-
-WeightPriceList()
+    @classmethod
+    def __setup__(cls):
+        super(WeightPriceList, cls).__setup__()
+        cls._order.insert(0, ('weight', 'ASC'))
diff -r b7bad438669f trytond/modules/carrier_weight/sale.py
--- a/trytond/modules/carrier_weight/sale.py	Thu Sep 13 12:41:15 2012 +0200
+++ b/trytond/modules/carrier_weight/sale.py	Mon Sep 24 20:36:40 2012 +0200
@@ -3,12 +3,14 @@
 from functools import partial
 from itertools import groupby
 
-from trytond.model import Model
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 
+__all__ = ['Sale']
+__metaclass__ = PoolMeta
 
-class Sale(Model):
-    _name = 'sale.sale'
+
+class Sale:
+    __name__ = 'sale.sale'
 
     def _group_parcel_key(self, lines, line):
         """
@@ -16,45 +18,30 @@
         """
         return None
 
-    def _get_carrier_context(self, values):
-        pool = Pool()
-        carrier_obj = pool.get('carrier')
-        product_obj = pool.get('product.product')
-        uom_obj = pool.get('product.uom')
+    def _get_carrier_context(self):
+        Uom = Pool().get('product.uom')
 
-        context = super(Sale, self)._get_carrier_context(values)
+        context = super(Sale, self)._get_carrier_context()
 
-        carrier = carrier_obj.browse(values['carrier'])
-        if carrier.carrier_cost_method != 'weight':
+        if self.carrier.carrier_cost_method != 'weight':
             return context
         context = context.copy()
         weights = []
         context['weights'] = weights
-        product_ids = [line['product'] for line in values.get('lines') or []
-            if line.get('product')]
-        id2product = dict((p.id, p) for p in product_obj.browse(product_ids))
-        unit_ids = [line['unit'] for line in values.get('lines') or []
-            if line.get('unit')]
-        id2unit = dict((u.id, u) for u in uom_obj.browse(unit_ids))
 
-        lines = values.get('lines') or []
+        lines = self.lines or []
         keyfunc = partial(self._group_parcel_key, lines)
         lines = sorted(lines, key=keyfunc)
 
         for key, parcel in groupby(lines, key=keyfunc):
             weight = 0
             for line in parcel:
-                if (line.get('product')
-                        and line.get('quantity')
-                        and line.get('unit')):
-                    product = id2product[line['product']]
-                    quantity = uom_obj.compute_qty(id2unit[line['unit']],
-                        line['quantity'], product.default_uom, round=False)
-                    if product.weight:
-                        weight += uom_obj.compute_qty(product.weight_uom,
-                            product.weight * quantity, carrier.weight_uom,
-                            round=False)
+                if line.product and line.quantity and line.unit:
+                    quantity = Uom.compute_qty(line.unit, line.quantity,
+                        line.product.default_uom, round=False)
+                    if line.product.weight:
+                        weight += Uom.compute_qty(line.product.weight_uom,
+                            line.product.weight * quantity,
+                            self.carrier.weight_uom, round=False)
             weights.append(weight)
         return context
-
-Sale()
diff -r b7bad438669f trytond/modules/carrier_weight/stock.py
--- a/trytond/modules/carrier_weight/stock.py	Thu Sep 13 12:41:15 2012 +0200
+++ b/trytond/modules/carrier_weight/stock.py	Mon Sep 24 20:36:40 2012 +0200
@@ -1,14 +1,16 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-from itertools import izip, groupby
+from itertools import groupby
 from functools import partial
 
-from trytond.model import Model
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 
+__all__ = ['ShipmentIn', 'ShipmentOut']
+__metaclass__ = PoolMeta
 
-class ShipmentIn(Model):
-    _name = 'stock.shipment.in'
+
+class ShipmentIn:
+    __name__ = 'stock.shipment.in'
 
     def _group_parcel_key(self, lines, line):
         """
@@ -16,53 +18,37 @@
         """
         return None
 
-    def _get_carrier_context(self, values):
-        pool = Pool()
-        carrier_obj = pool.get('carrier')
-        product_obj = pool.get('product.product')
-        uom_obj = pool.get('product.uom')
+    def _get_carrier_context(self):
+        Uom = Pool().get('product.uom')
 
-        context = super(ShipmentIn, self)._get_carrier_context(values)
-        if not values.get('carrier'):
+        context = super(ShipmentIn, self)._get_carrier_context()
+        if not self.carrier:
             return context
-        carrier = carrier_obj.browse(values['carrier'])
-        if carrier.carrier_cost_method != 'weight':
+        if self.carrier.carrier_cost_method != 'weight':
             return context
         context = context.copy()
         weights = []
         context['weights'] = weights
-        product_ids = [line['product']
-            for line in values.get('incoming_moves') or []
-            if line.get('product')]
-        id2product = dict((p.id, p) for p in product_obj.browse(product_ids))
-        uom_ids = [line['uom'] for line in values.get('incoming_moves') or []
-            if line.get('uom')]
-        id2uom = dict((u.id, u) for u in uom_obj.browse(uom_ids))
 
-        lines = values.get('incoming_moves') or []
+        lines = self.incoming_moves or []
         keyfunc = partial(self._group_parcel_key, lines)
         lines = sorted(lines, key=keyfunc)
 
         for key, parcel in groupby(lines, key=keyfunc):
             weight = 0
             for line in parcel:
-                if (line.get('product')
-                        and line.get('quantity')
-                        and line.get('uom')):
-                    product = id2product[line['product']]
-                    quantity = uom_obj.compute_qty(id2uom[line['uom']],
-                        line['quantity'], product.default_uom, round=False)
-                    weight += uom_obj.compute_qty(product.weight_uom,
-                        product.weight * quantity, carrier.weight_uom,
-                        round=False)
+                if line.product and line.quantity and line.uom:
+                    quantity = Uom.compute_qty(line.uom, line.quantity,
+                        line.product.default_uom, round=False)
+                    weight += Uom.compute_qty(line.product.weight_uom,
+                        line.product.weight * quantity,
+                        self.carrier.weight_uom, round=False)
             weights.append(weight)
         return context
 
-ShipmentIn()
 
-
-class ShipmentOut(Model):
-    _name = 'stock.shipment.out'
+class ShipmentOut:
+    __name__ = 'stock.shipment.out'
 
     def _group_parcel_key(self, lines, line):
         """
@@ -70,61 +56,30 @@
         """
         return None
 
-    def _get_carrier_context(self, values):
-        pool = Pool()
-        carrier_obj = pool.get('carrier')
-        product_obj = pool.get('product.product')
-        uom_obj = pool.get('product.uom')
+    def _get_carrier_context(self):
+        Uom = Pool().get('product.uom')
 
-        context = super(ShipmentOut, self)._get_carrier_context(values)
-        if not values.get('carrier'):
+        context = super(ShipmentOut, self)._get_carrier_context()
+        if not self.carrier:
             return context
-        carrier = carrier_obj.browse(values['carrier'])
-        if carrier.carrier_cost_method != 'weight':
+        if self.carrier.carrier_cost_method != 'weight':
             return context
         context = context.copy()
         weights = []
         context['weights'] = weights
-        product_ids = [line['product']
-            for line in values.get('inventory_moves') or []
-            if line.get('product')]
-        id2product = dict((p.id, p) for p in product_obj.browse(product_ids))
-        uom_ids = [line['uom'] for line in values.get('inventory_moves') or []
-            if line.get('uom')]
-        id2uom = dict((u.id, u) for u in uom_obj.browse(uom_ids))
 
-        lines = values.get('inventory_moves') or []
+        lines = self.inventory_moves or []
         keyfunc = partial(self._group_parcel_key, lines)
         lines = sorted(lines, key=keyfunc)
 
         for key, parcel in groupby(lines, key=keyfunc):
             weight = 0
             for line in parcel:
-                if (line.get('product')
-                        and line.get('quantity')
-                        and line.get('uom')):
-                    product = id2product[line['product']]
-                    quantity = uom_obj.compute_qty(id2uom[line['uom']],
-                        line['quantity'], product.default_uom, round=False)
-                    weight += uom_obj.compute_qty(product.weight_uom,
-                        product.weight * quantity, carrier.weight_uom,
-                        round=False)
+                if line.product and line.quantity and line.uom:
+                    quantity = Uom.compute_qty(line.uom, line.quantity,
+                        line.product.default_uom, round=False)
+                    weight += Uom.compute_qty(line.product.weight_uom,
+                        line.product.weight * quantity,
+                        self.carrier.weight_uom, round=False)
             weights.append(weight)
         return context
-
-    def get_carrier_context(self, shipment, values=None):
-        if values is None:
-            values = {}
-        values = values.copy()
-        inventory_moves = [{
-                'product': m.product.id,
-                'quantity': m.quantity,
-                'uom': m.uom.id,
-                } for m in shipment.inventory_moves]
-        values.setdefault('inventory_moves', inventory_moves)
-        for new, old in izip(inventory_moves, values['inventory_moves']):
-            old.update(new)
-        return super(ShipmentOut, self).get_carrier_context(shipment,
-            values=values)
-
-ShipmentOut()
diff -r b7bad438669f trytond/modules/carrier_weight/tests/test_carrier_weight.py
--- a/trytond/modules/carrier_weight/tests/test_carrier_weight.py	Thu Sep 13 12:41:15 2012 +0200
+++ b/trytond/modules/carrier_weight/tests/test_carrier_weight.py	Mon Sep 24 20:36:40 2012 +0200
@@ -50,37 +50,36 @@
         Test compute_weight_price.
         '''
         with Transaction().start(DB_NAME, USER, context=CONTEXT):
-            party_id = self.party.create({
+            party = self.party.create({
                     'name': 'Carrier',
                     })
-            uom_id, = self.uom.search([
+            uom, = self.uom.search([
                     ('name', '=', 'Unit'),
                     ])
-            category_id = self.category.create({
+            category = self.category.create({
                     'name': 'Category',
                     })
-            product_id = self.product.create({
+            product = self.product.create({
                     'name': 'Carrier',
-                    'default_uom': uom_id,
-                    'category': category_id,
+                    'default_uom': uom.id,
+                    'category': category.id,
                     'type': 'service',
                     'list_price': Decimal(0),
                     'cost_price': Decimal(0),
                     })
-            weight_uom_id, = self.uom.search([
+            weight_uom, = self.uom.search([
                     ('name', '=', 'Kilogram'),
                     ])
-            currency_id, = self.currency.search([
+            currency, = self.currency.search([
                     ('code', '=', 'cu1'),
                     ])
-            carrier_id = self.carrier.create({
-                    'party': party_id,
-                    'carrier_product': product_id,
+            carrier = self.carrier.create({
+                    'party': party.id,
+                    'carrier_product': product.id,
                     'carrier_cost_method': 'weight',
-                    'weight_uom': weight_uom_id,
-                    'weight_currency': currency_id,
+                    'weight_uom': weight_uom.id,
+                    'weight_currency': currency.id,
                     })
-            carrier = self.carrier.browse(carrier_id)
             for i, weight in enumerate(xrange(0, 100, 20)):
                 self.weight_price_list.create({
                         'carrier': carrier.id,
@@ -88,7 +87,7 @@
                         'price': Decimal(i),
                         })
             self.assertEqual(
-                self.carrier.compute_weight_price(carrier, 0), Decimal(0))
+                carrier.compute_weight_price(0), Decimal(0))
             for weight, price in [
                     (1, Decimal(0)),
                     (10, Decimal(0)),
@@ -98,8 +97,7 @@
                     (81, Decimal(4)),
                     (100, Decimal(4)),
                     ]:
-                self.assertEqual(
-                    self.carrier.compute_weight_price(carrier, weight), price)
+                self.assertEqual(carrier.compute_weight_price(weight), price)
 
 
 def doctest_dropdb(test):
diff -r bfedb8605d86 trytond/modules/company/__init__.py
--- a/trytond/modules/company/__init__.py	Fri Sep 21 15:20:25 2012 +0200
+++ b/trytond/modules/company/__init__.py	Mon Sep 24 20:36:40 2012 +0200
@@ -1,6 +1,29 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .company import *
 from .cron import *
-from . import party
+from .party import *
+
+
+def register():
+    Pool.register(
+        Company,
+        Employee,
+        UserEmployee,
+        User,
+        Property,
+        Sequence,
+        SequenceStrict,
+        CompanyConfigStart,
+        Cron,
+        CronCompany,
+        PartyConfiguration,
+        module='company', type_='model')
+    Pool.register(
+        CompanyConfig,
+        module='company', type_='wizard')
+    Pool.register(
+        LetterReport,
+        module='company', type_='report')
